/*      Author: Jan Dolezel, http://www.eithel.net
 *	Last version: http://www.eithel.net/download/ui/spiral
 *	Last modified: 2006-12-24
 *
 *	License Information:
 *	-------------------------------------------------------------------------
 *	Copyright (C) 2005 Jan Dolezel
 *
 *	This program is free software; you can redistribute it and/or modify it
 *	under the terms of the GNU General Public License v2 as published by the
 *	Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful, but
 *	WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *	General Public License for more details.
 */

package spirals.data.doubleViewers;

import javax.swing.JPanel;
import java.awt.Color;
import java.awt.Graphics;

/**
 * <p>Vykresluje data v zvislosti na ad x.</p>
 *
 * <p>Copyright: Copyright (c) 2005 Jan Dolezel</p>
 * <p>Company: VUT FEL, Prague</p>
 *
 * @see spirals.data.doubleViewers.DoubleViewer DoubleViewer
 * @author Jan Dolezel
 * @version 1.2.0
 */
public class DoubleViewerBottom2
    extends DoubleViewerBottom {
  protected double[] x;

  public DoubleViewerBottom2(JPanel screen, double[] x, double[] data) {
    super(screen, data);
    this.x = x;
  }

  protected void paintGraph(Graphics g, int scrWidth, int offsetFi, double koef) {
    int x, ox = 0;
    int y, oy = offsetFi;
    if (size > 0) {
      double xk = (double)this.x[this.x.length - 1] / (double) scrWidth;
      g.setColor(Color.BLACK);
      for (int i = 0; i < size; i++) {
        x = (int) ( (double)this.x[i] / xk);
        y = offsetFi - (int) (data[i] * koef);

        this.setDrawColor(g, i);
        g.drawLine(x, y, ox, oy);
        ox = x;
        oy = y;
      }
    }
  }
}
