/*      Author: Jan Dolezel, http://www.eithel.net
 *	Last version: http://www.eithel.net/download/ui/spiral
 *	Last modified: 2006-12-24
 *
 *	License Information:
 *	-------------------------------------------------------------------------
 *	Copyright (C) 2005 Jan Dolezel
 *
 *	This program is free software; you can redistribute it and/or modify it
 *	under the terms of the GNU General Public License v2 as published by the
 *	Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful, but
 *	WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *	General Public License for more details.
 */

package spirals.data.doubleViewers;

import javax.swing.JPanel;
import spirals.motol.database.Data;
import java.awt.event.*;
import java.awt.Cursor;

/**
 * <p>Umonuje my vyznaovat sek dat.</p>
 *
 * <p>Copyright: Copyright (c) 2005 Jan Dolezel</p>
 * <p>Company: VUT FEL, Prague</p>
 *
 * @author Jan Dolezel
 * @version 1.2.0
 */
public abstract class DoubleViewerDrag
    extends DoubleViewer implements MouseListener, MouseMotionListener {
  protected boolean dragging;

  public DoubleViewerDrag(JPanel screen, JPanel controls, Data data,
                                boolean all, boolean showUp) {
    super(screen, controls, data, all, showUp);
    this.install();
  }

  private void install() {
    bottom.addMouseListener(this);
    bottom.addMouseMotionListener(this);
    bottom.setCursor(Cursor.getPredefinedCursor(Cursor.CROSSHAIR_CURSOR));
  }

  public void mouseEntered(MouseEvent m) {}

  public void mousePressed(MouseEvent m) {}

  public void mouseClicked(MouseEvent m) {}

  public void mouseMoved(MouseEvent m) {
    bottomViewer.setWhiteX(m.getX());
    bottom.repaint();
  }

  public void mouseExited(MouseEvent m) {
    bottomViewer.setWhiteX( -1);
    bottom.repaint();
  }

  public void mouseReleased(MouseEvent m) {
    dragging = false;
  }

  /**
   * pi taen my vyznauj data
   * @param m MouseEvent
   */
  public void mouseDragged(MouseEvent m) {
    int width = (int) ( (double) m.getX() /
                       (bottom.getWidth() - 2 * bottomViewer.getOffset()) *
                       bottomViewer.getSize()) - bottomViewer.getOffset();

    if (dragging) {
      bottomViewer.setEnd(width);
      topViewer.setEnd(width);
    }
    else {
      dragging = true;
      bottomViewer.setBegin(width);
      topViewer.setBegin(width);
    }
    bottomViewer.setWhiteX(m.getX());
    repaint();
  }
}
