/*      Author: Jan Dolezel, http://www.eithel.net
 *	Last version: http://www.eithel.net/download/ui/spiral
 *	Last modified: 2006-12-24
 *
 *	License Information:
 *	-------------------------------------------------------------------------
 *	Copyright (C) 2005 Jan Dolezel
 *
 *	This program is free software; you can redistribute it and/or modify it
 *	under the terms of the GNU General Public License v2 as published by the
 *	Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful, but
 *	WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *	General Public License for more details.
 */

package spirals.data.doubleViewers;

import javax.swing.JPanel;
import spirals.data.viewers.ZoomTabletDataViewer;
import spirals.motol.database.Data;
import java.awt.*;

/**
 * <p>Zkladn tda pro zobrazovn dat v hornm panelu. Je st dvouokenho prohlee</p>
 *
 * <p>Copyright: Copyright (c) 2005 Jan Dolezel</p>
 * <p>Company: VUT FEL, Prague</p>
 *
 * @see spirals.data.doubleViewers.DoubleViewer DoubleViewer
 * @author Jan Dolezel
 * @version 1.2.0
 */
public class DoubleViewerTop
    extends ZoomTabletDataViewer {
  /**
   * index zatku vyznaovanch dat
   */
  protected int begin = -1;
  /**
   * index konce vyznaovanch dat
   */
  protected int end = -1;

  public DoubleViewerTop(JPanel screen, JPanel controls, Data data,
                         boolean all, boolean showUp) {
    super(screen, controls, data, all, showUp);
  }

  /**
   * vyznaen sek dat kresli erven
   * @param g Graphics
   * @param index int
   */
  protected void setDrawColor(Graphics g, int index) {
    if ( ( (index >= begin) && (index <= end)) ||
        ( (index >= end) && (index <= begin))) {
      g.setColor(Color.RED);
    }
    else {
      g.setColor(Color.BLACK);
    }
  }

  public void setBegin(int begin) {
    this.begin = begin;
    this.end = begin;
  }

  public void setEnd(int end) {
    this.end = end;
  }
}
