/*      Author: Jan Dolezel, http://www.eithel.net
 *	Last version: http://www.eithel.net/download/ui/spiral
 *	Last modified: 2006-12-24
 *
 *	License Information:
 *	-------------------------------------------------------------------------
 *	Copyright (C) 2005 Jan Dolezel
 *
 *	This program is free software; you can redistribute it and/or modify it
 *	under the terms of the GNU General Public License v2 as published by the
 *	Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful, but
 *	WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *	General Public License for more details.
 */

package spirals.data.doubleViewers;

import javax.swing.JPanel;
import spirals.motol.database.Data;
import mathutil.FFT;
import mathutil.ComplexVector;

/**
 * <p>Prohle vykresl kepstrum vypotan z dat.</p>
 *
 * <p>Copyright: Copyright (c) 2005 Jan Dolezel</p>
 * <p>Company: VUT FEL, Prague</p>
 *
 * @author Jan Dolezel
 * @version 1.2.0
 */
public class KepsterTabletDataViewer
    extends FFTTabletDataViewer {
  protected ComplexVector kepstrum;

  public KepsterTabletDataViewer(JPanel screen, JPanel controls, Data data,
                                 boolean all, boolean showUp) {
    super(screen, controls, data, all, showUp);
    this.install();
  }

  private void install() {
    bottomViewer = new FFTBottom(bottom, kepstrum.getPowerSpectrum().toArray());
    bottomViewer.setMax(1E-6);
    ( (FFTBottom) bottomViewer).setMaxFrequency(1000);
  }

  public void updateData() {
    super.updateData();
    if(dcb != null) {
      kepstrum = FFT.fft(fft, fftSize);
    }
  }

  public String getDescription() {
    return "Kepstrum potan na hel s odstrannm stejnosmrn sloky.";
  }
}
