/*      Author: Jan Dolezel, http://www.eithel.net
 *	Last version: http://www.eithel.net/download/ui/spiral
 *	Last modified: 2006-12-24
 *
 *	License Information:
 *	-------------------------------------------------------------------------
 *	Copyright (C) 2005 Jan Dolezel
 *
 *	This program is free software; you can redistribute it and/or modify it
 *	under the terms of the GNU General Public License v2 as published by the
 *	Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful, but
 *	WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *	General Public License for more details.
 */

package spirals.data.doubleViewers;

import javax.swing.*;
import spirals.motol.database.Data;

/**
 * <p>Zobrazuje graf tlaku.</p>
 *
 * <p>Copyright: Copyright (c) 2005 Jan Dolezel</p>
 * <p>Company: VUT FEL, Prague</p>
 *
 * @author Jan Dolezel
 * @version 1.2.0
 */
public class PressureTabletDataViewer
    extends DoubleViewerDrag {

  private double[] pressure;

  public PressureTabletDataViewer(JPanel screen, JPanel controls,
                                       Data data, boolean all, boolean showUp) {
    super(screen, controls, data, all, showUp);
    this.install();
  }

  private void install() {
    topViewer = new DoubleViewerTop(top, topControls, data, all, showUp);

    bottomViewer = new DoubleViewerBottom(bottom, pressure);
    bottomViewer.setMax(1024);
    bottomViewer.setMin(0);
  }

  public void updateData() {
    super.updateData();

    int size = tabletData.size();
    pressure = new double[size];

    for (int i = 0; i < size; i++) {
      pressure[i] = tabletData.get(i).getNormalPressure();
    }
  }

  public String getDescription() {
    return "Graf tlaku.";
  }
}
