/*      Author: Jan Dolezel, http://www.eithel.net
 *	Last version: http://www.eithel.net/download/ui/spiral
 *	Last modified: 2006-12-24
 *
 *	License Information:
 *	-------------------------------------------------------------------------
 *	Copyright (C) 2005 Jan Dolezel
 *
 *	This program is free software; you can redistribute it and/or modify it
 *	under the terms of the GNU General Public License v2 as published by the
 *	Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful, but
 *	WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *	General Public License for more details.
 */

package spirals.data.doubleViewers;

import javax.swing.JPanel;
import spirals.motol.database.Data;
import mathutil.SavitzkyGolayFilter;
import mathutil.Vektor;

/**
 * <p>Prohle rozdlu filtrovan a pvodnho vektoru hl.</p>
 *
 * <p>Copyright: Copyright (c) 2005 Jan Dolezel</p>
 * <p>Company: VUT FEL, Prague</p>
 *
 * @author Jan Dolezel
 * @version 1.2.0
 */
public class TimeDifTabletDataViewer
    extends TimeTabletDataViewer {
  protected Vektor dif;

  public TimeDifTabletDataViewer(JPanel screen, JPanel controls,
                                      Data data, boolean all, boolean showUp) {
    super(screen, controls, data, all, showUp);
  }

  public void updateData() {
    super.updateData();

    if(dcb != null) {
      int len = 2 * (int) Math.ceil(700 / tabletData.getMeanVelocityUpdated()) + 1;
      double filtAngle[] = SavitzkyGolayFilter.filter(angle, 1, len);
    //    double filtAngle[] = SavitzkyGolayFilter.filterAdaptive(angle, 1, len);
      dif = new Vektor(angle).substract(new Vektor(filtAngle));

      double min = Double.MAX_VALUE, max = Double.MIN_VALUE;
      for (int i = dif.getLength() - 1; i >= 0; i--) {
        min = Math.min(min, dif.get(i));
        max = Math.max(max, dif.get(i));
      }
      this.setBottom(dif.toArray(), min, max);
    }
  }

  public String getDescription() {
    return "Graf v zvislosti na ase - bez stejnosmrn sloky. Ta je odfiltrovna Savitzky-Golay filtrem du jedna s velkm oknem. Taenm my pi stisknutm levm tlatku, lze v dolnm grafu zvraznit sek.";
  }
}
