/*      Author: Jan Dolezel, http://www.eithel.net
 *	Last version: http://www.eithel.net/download/ui/spiral
 *	Last modified: 2006-12-24
 *
 *	License Information:
 *	-------------------------------------------------------------------------
 *	Copyright (C) 2005 Jan Dolezel
 *
 *	This program is free software; you can redistribute it and/or modify it
 *	under the terms of the GNU General Public License v2 as published by the
 *	Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful, but
 *	WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *	General Public License for more details.
 */

package spirals.motol;

import javax.swing.*;
import spirals.motol.database.*;
import java.awt.*;
import spirals.motol.gui.MainFrame;

/**
 * <p>Here it all begins. Entry class for programm.</p>
 * <p>First is read configuration file, then opened main frame window which start
 * database engine and there is performed rest of initialization.</p>
 *
 * <p>Copyright: Copyright (c) 2005 Jan Dolezel</p>
 * <p>Company: VUT FEL, Prague</p>
 *
 * @author Jan Dolezel
 * @version 1.2
 */
public class ParkinsonDiseaseDatabase {
  /**
   * Construct and show the application.
   * @param conf configuration of application
   */
  public ParkinsonDiseaseDatabase(Configuration conf) {
    // crete and center frame
    MainFrame mf = new MainFrame(conf);
    mf.validate();
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = mf.getSize();
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }
    mf.setLocation( (screenSize.width - frameSize.width) / 2,
                   (screenSize.height - frameSize.height) / 2);
    mf.setVisible(true);
  }

  /**
   * Application entry point.
   */
  public static void main(String[] args) {
    SwingUtilities.invokeLater(new Runnable() {
      public void run() {
        Configuration conf = new Configuration();
        try {
          UIManager.setLookAndFeel(conf.getLafClass());
        }
        catch (Exception exception) {
          exception.printStackTrace();
        }

        new ParkinsonDiseaseDatabase(conf);
      }
    });
  }
}
