/*      Author: Jan Dolezel, http://www.eithel.net
 *	Last version: http://www.eithel.net/download/ui/spiral
 *	Last modified: 2006-12-24
 *
 *	License Information:
 *	-------------------------------------------------------------------------
 *	Copyright (C) 2005 Jan Dolezel
 *
 *	This program is free software; you can redistribute it and/or modify it
 *	under the terms of the GNU General Public License v2 as published by the
 *	Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful, but
 *	WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *	General Public License for more details.
 */

package spirals.motol.loaders;

import spirals.data.TabletData;
import spirals.motol.database.*;
import java.util.Date;

/**
 * <p>Tda, kter se star o nahrn nasnmanch dat z njakho loit.</p>
 *
 * <p>Copyright: Copyright (c) 2005 Jan Dolezel</p>
 * <p>Company: VUT FEL, Prague</p>
 *
 * @author Jan Dolezel
 * @version 1.2.0
 */
abstract public class DataLoader {
  protected static DataLoader instance = null;

  protected DataLoader() {}

  public static DataLoader getInstance() {
    return instance;
  }

  /**
   * Nahraje popis dat z loit. Data jsou identifikovna nvtvou a datumem.
   * @param data Data do tto tdy ulo data
   * @param visit Visit pro kterou nvtvu data nahrt
   * @param date Date identifiktor dat
   */
  public abstract void load(Data data, Visit visit, Date date);

  /**
   * ulo data
   * @param data Data co uloit
   * @param saveData boolean uloit i nasnman data nebo jenom popis
   */
  public abstract void save(Data data, boolean saveData);

  /**
   * nahraje z loit vlastn nasnman data
   * @param data Data
   * @return TabletData
   */
  public abstract TabletData getData(Data data);
}
