/*      Author: Jan Dolezel, http://www.eithel.net
 *	Last version: http://www.eithel.net/download/ui/spiral
 *	Last modified: 2006-12-24
 *
 *	License Information:
 *	-------------------------------------------------------------------------
 *	Copyright (C) 2005 Jan Dolezel
 *
 *	This program is free software; you can redistribute it and/or modify it
 *	under the terms of the GNU General Public License v2 as published by the
 *	Free Software Foundation.
 *
 *	This program is distributed in the hope that it will be useful, but
 *	WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *	General Public License for more details.
 */

package spirals.motol.loaders;

import spirals.data.TabletData;
import spirals.motol.database.*;
import java.util.Date;

/**
 * <p>Tda, kter se star o nahrn nvtvy z njakho loit.</p>
 *
 * <p>Copyright: Copyright (c) 2005 Jan Dolezel</p>
 * <p>Company: VUT FEL, Prague</p>
 *
 * @author Jan Dolezel
 * @version 1.2.0
 */
abstract public class VisitLoader {
  protected static VisitLoader instance = null;

  protected VisitLoader() {}

  public static VisitLoader getInstance() {return instance;}

  public abstract DataLoader getDefaultDataLoader();
  /**
   * Nahraje nvtvu z loit. Nvtva je jednoznan identifikovna pacientem a datumem
   * @param visit Visit do tto tdy nvtvu ulo
   * @param pacient Pacient ke ktermu pacientovi nvtva pat
   * @param date Date identifiktor nvtvy
   */
  public abstract void load(Visit visit, Pacient pacient, Date date);
  public abstract void save(Visit visit);

  /**
   * slou data dvou nvtv
   * @param loader DataLoader implicitn nahrava dat
   * @param visit Visit ke komu data pidat
   * @param temp Visit kter data pidat
   */
  public static void merge(DataLoader loader, Visit visit, Visit temp) {
    for (Data nd : temp.getData()) {
      TabletData td = nd.getAllData(); // kvli cacheovn
      if(visit == null) {
        nd.setLoader(loader);
      } else {
        nd.setVisit(visit);
      }

      nd.save(true);
    }
  }
}
